// Include SwaggerUI header
#include <SwaggerUI.h>

// Include other headers for your project
#include <ESP8266WebServer.h>
#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>

#ifndef STASSID
#define STASSID "your-ssid"
#define STAPSK  "your-password"
#endif

const char* ssid = STASSID;
const char* password = STAPSK;


// Convert the compressed specification file as an array of bytes by using the following commands:
// cat [swagger.json] | gzip -9 > swagger.json.gz && bin2c swagger.json.gz
// Then copy the generated bytes array here to store the specification file in flash
const char swagger_json[1136UL + 1] = {
  0x1F, 0x8B, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x03, 0xE5, 0x58, 0x51, 0x6F, 0xDB, 0x36, 0x10, 0xFE, 0x2B, 0x9C, 0xBA, 0xC7, 0xC4, 0x8A, 0xB3, 0x22, 0xE8, 0xFC, 0xD4, 0x34, 0x45, 0xD7, 0x62, 0x58, 0x33, 0xC4, 0xED, 0xFA, 0x50, 0xE4,
  0x81, 0x96, 0xCE, 0x16, 0x13, 0x49, 0xE4, 0x48, 0xCA, 0xAA, 0x11, 0xF8, 0xBF, 0xEF, 0x8E, 0xA4, 0x6C, 0x59, 0x96, 0x17, 0x25, 0x6D, 0x82, 0x01, 0xCB, 0x4B, 0x6C, 0xE9, 0xEE, 0xBB, 0xFB, 0x3E, 0xDE, 0x1D, 0x49, 0xDF, 0x45, 0x52, 0x41, 0xC9,
  0x95, 0x88, 0x26, 0xD1, 0x2F, 0xA3, 0x93, 0xD1, 0x38, 0x3A, 0x8A, 0x44, 0x39, 0x97, 0xD1, 0xE4, 0x2E, 0xB2, 0xC2, 0xE6, 0x80, 0xCF, 0xA7, 0x35, 0x5F, 0xBC, 0x7E, 0x2F, 0x0B, 0xC0, 0x77, 0x29, 0x98, 0x44, 0x0B, 0x65, 0x85, 0x2C, 0xF1, 0xCD,
  0x1B, 0x6E, 0x44, 0xC2, 0xE0, 0x1B, 0x2F, 0x54, 0x0E, 0x4C, 0xCE, 0x19, 0x2F, 0xD9, 0x25, 0xE2, 0x9D, 0xFF, 0xF9, 0x81, 0x19, 0x05, 0x89, 0x98, 0x8B, 0x84, 0x93, 0x2D, 0xB3, 0x12, 0xCD, 0x94, 0x34, 0x68, 0x55, 0x92, 0xD5, 0x1F, 0x17, 0x9F,
  0x11, 0x6D, 0x09, 0xDA, 0x78, 0xA4, 0x31, 0xC6, 0x3E, 0x89, 0xD6, 0x47, 0x91, 0x01, 0x4D, 0x4F, 0xA3, 0xC9, 0xD7, 0xBB, 0xA8, 0xD2, 0x39, 0xBE, 0xCA, 0xAC, 0x55, 0x93, 0x38, 0x06, 0xA3, 0x5E, 0x9D, 0x9E, 0x9D, 0x8D, 0x72, 0x99, 0xF0, 0x3C,
  0xC6, 0x8C, 0xE3, 0xE5, 0x18, 0x1D, 0xDA, 0x56, 0x66, 0x98, 0x19, 0x5A, 0x8D, 0x7F, 0x3D, 0x1D, 0x8D, 0xCF, 0x5E, 0x8D, 0x5E, 0x8E, 0xC6, 0x87, 0xA1, 0xFA, 0x8C, 0xAE, 0x8F, 0x22, 0xCB, 0x17, 0x3E, 0xBD, 0x92, 0x17, 0x24, 0xCF, 0x85, 0x2C,
  0xAD, 0x96, 0xF9, 0x01, 0x71, 0x12, 0xFF, 0xD6, 0x90, 0x3A, 0x36, 0x03, 0x96, 0xC2, 0x52, 0x24, 0xE0, 0xA2, 0x05, 0xFF, 0xCF, 0x2A, 0xE5, 0x76, 0x5F, 0xDB, 0x00, 0xEB, 0x9C, 0x2A, 0x67, 0xE2, 0x30, 0x56, 0xB2, 0xD2, 0x3D, 0x20, 0x5F, 0xC4,
  0x3B, 0xF1, 0xAF, 0x10, 0x64, 0xC0, 0x0C, 0x58, 0x2B, 0xCA, 0xC5, 0x3E, 0x10, 0xD2, 0x52, 0xDC, 0x66, 0x86, 0x96, 0x3D, 0x0E, 0x29, 0xC7, 0x3C, 0xE7, 0xBA, 0xA0, 0x27, 0x0B, 0xB0, 0xAE, 0x1E, 0x3C, 0xF1, 0x0D, 0x61, 0x74, 0x32, 0x55, 0x51,
  0x70, 0xBD, 0xC2, 0x58, 0xBF, 0x81, 0x75, 0x71, 0x9C, 0x93, 0x61, 0x73, 0xA9, 0x59, 0x9D, 0x41, 0xD9, 0xE2, 0xCC, 0x6A, 0x91, 0xE7, 0xAC, 0xE6, 0xB7, 0x50, 0x29, 0x4C, 0x55, 0xE3, 0x4A, 0xC9, 0xD2, 0x80, 0x8B, 0x79, 0x7A, 0x72, 0x42, 0xFF,
  0x76, 0xD3, 0x3F, 0x27, 0x28, 0x96, 0x0B, 0x63, 0x99, 0x06, 0xAB, 0x05, 0x2C, 0x21, 0x45, 0x47, 0x4A, 0x0F, 0x4A, 0x97, 0x11, 0x57, 0x2A, 0x0F, 0x15, 0x16, 0xDF, 0x18, 0x72, 0xBA, 0x8B, 0x4C, 0x92, 0x41, 0xC1, 0xE9, 0xD3, 0xCF, 0x1A, 0xE6,
  0x08, 0xF3, 0x02, 0x09, 0x15, 0x18, 0x0A, 0x7D, 0x4C, 0xEC, 0xDF, 0x9A, 0xF8, 0x2A, 0x44, 0x8F, 0xD6, 0xEE, 0x0F, 0xE9, 0x4B, 0x73, 0x3F, 0xC9, 0x29, 0x58, 0x43, 0xD5, 0xEB, 0x48, 0x52, 0x4D, 0x7B, 0x36, 0x6D, 0x92, 0xDC, 0x32, 0xCE, 0x16,
  0x62, 0x49, 0xD4, 0x85, 0x6B, 0x99, 0xA1, 0x44, 0x71, 0x71, 0x9E, 0x88, 0x1D, 0xD2, 0xDB, 0x2C, 0xAA, 0x92, 0x35, 0x68, 0x39, 0x9F, 0x13, 0xC4, 0x30, 0xCE, 0x59, 0x85, 0xA4, 0x53, 0x59, 0xB7, 0xD7, 0x72, 0x10, 0xAD, 0xB7, 0x5E, 0x11, 0x61,
  0x98, 0x41, 0x0C, 0xAC, 0x3B, 0x87, 0xF2, 0x0C, 0x1C, 0x35, 0xCC, 0xA4, 0xB4, 0x83, 0x19, 0x7E, 0xD2, 0x62, 0xB1, 0x00, 0x8D, 0xEB, 0xE6, 0x1D, 0x3B, 0xAD, 0xFA, 0x00, 0xAA, 0xAE, 0xC2, 0x3D, 0xC8, 0x4F, 0xCF, 0xC2, 0xD3, 0xC0, 0xE3, 0x68,
  0xA2, 0xDF, 0x2E, 0x4B, 0x26, 0x4A, 0x96, 0x70, 0xE3, 0x86, 0x38, 0xBA, 0x56, 0xB3, 0x1C, 0xC7, 0x4D, 0x2D, 0x6C, 0xE6, 0x6C, 0x9A, 0xB9, 0xF1, 0x08, 0x2D, 0xD0, 0xF5, 0x29, 0xA5, 0xA8, 0x71, 0x8B, 0x89, 0x8D, 0xE5, 0x3E, 0xF6, 0xDE, 0xA8,
  0x72, 0x63, 0x71, 0x47, 0x85, 0xAB, 0x30, 0x49, 0x58, 0x52, 0x69, 0x8D, 0xE8, 0x7E, 0x30, 0x96, 0x60, 0x6B, 0xA9, 0x6F, 0xB7, 0x03, 0x92, 0x58, 0x07, 0x99, 0x73, 0xD4, 0xCC, 0xEA, 0x15, 0xB5, 0x3B, 0x3E, 0x29, 0x21, 0xC1, 0x41, 0x27, 0x07,
  0x29, 0x71, 0x11, 0x42, 0x04, 0x37, 0xDA, 0x07, 0xB7, 0x01, 0x68, 0x43, 0xC4, 0xD1, 0x46, 0x6D, 0xD1, 0x4E, 0xE1, 0x47, 0x69, 0x45, 0x98, 0xD3, 0x66, 0xD9, 0x0E, 0x0D, 0xB9, 0x7D, 0x79, 0xA6, 0x61, 0x8C, 0xF7, 0xA5, 0x1C, 0x0A, 0xA6, 0x2D,
  0x8B, 0xA4, 0x69, 0x78, 0x88, 0x87, 0x86, 0xBF, 0x2B, 0x30, 0xF6, 0x8D, 0x4C, 0x57, 0x14, 0xF4, 0x69, 0x68, 0x0D, 0x5A, 0x87, 0x1E, 0x32, 0x2E, 0x85, 0x27, 0xDB, 0x4F, 0x36, 0xA5, 0xC9, 0x93, 0x04, 0x8C, 0x39, 0x56, 0x52, 0xF8, 0x08, 0xC3,
  0xEB, 0xB3, 0x2B, 0xFB, 0x4E, 0x9D, 0x26, 0x1A, 0xF0, 0x40, 0x90, 0xB2, 0xD9, 0xEA, 0xA1, 0x93, 0x6A, 0xFA, 0x18, 0xD8, 0xFF, 0x78, 0x45, 0x0E, 0x94, 0xE6, 0x7F, 0x5D, 0x8D, 0xFE, 0x08, 0xD9, 0xB7, 0x59, 0x84, 0xF3, 0xE7, 0x8E, 0xE8, 0x17,
  0x19, 0x24, 0xB7, 0x4C, 0xB8, 0x03, 0xBD, 0xF7, 0xF4, 0x5D, 0xEE, 0x0F, 0x76, 0xEE, 0xE8, 0xD8, 0x1A, 0x03, 0xBC, 0x4C, 0x71, 0x42, 0xFA, 0xDD, 0x45, 0xA0, 0x8D, 0x28, 0x71, 0x22, 0xE7, 0xF9, 0xA0, 0x7A, 0xC4, 0xEB, 0x82, 0x0E, 0x57, 0x04,
  0x8F, 0xF0, 0x0C, 0x2A, 0xC4, 0x09, 0xD1, 0xEB, 0x69, 0xC7, 0x07, 0x49, 0x31, 0x88, 0xDE, 0x47, 0xA8, 0xB1, 0xE8, 0x58, 0xB8, 0xE8, 0x30, 0xBE, 0xE4, 0x22, 0xE7, 0xB8, 0xB9, 0x32, 0xBA, 0x64, 0xE9, 0xC2, 0xEF, 0x5B, 0x3F, 0x88, 0xEF, 0x3B,
  0xA1, 0x8B, 0x9A, 0x6B, 0xF8, 0x2B, 0xDC, 0xAA, 0xF6, 0x69, 0x57, 0xC6, 0xCA, 0xE2, 0x78, 0x1E, 0xEC, 0x86, 0x16, 0xC3, 0x07, 0xBF, 0x9C, 0x78, 0x70, 0xF0, 0x00, 0xB8, 0xCA, 0x33, 0x51, 0xE2, 0x3B, 0xD6, 0x20, 0xD1, 0xA5, 0xEE, 0x11, 0xCD,
  0x26, 0x13, 0x0B, 0xF6, 0xD8, 0x58, 0xEC, 0xD8, 0x62, 0x97, 0xA6, 0x5D, 0x29, 0xBA, 0xD5, 0xE0, 0x2B, 0x6C, 0x0F, 0xC4, 0xF3, 0x5A, 0xE1, 0x13, 0x1F, 0x78, 0x70, 0xAF, 0x3D, 0x63, 0x75, 0xAD, 0x09, 0xB7, 0xB1, 0x72, 0x30, 0x80, 0x47, 0x0C,
  0x61, 0x57, 0x53, 0x72, 0xF0, 0x39, 0xCE, 0xE8, 0x4A, 0x78, 0x5E, 0xD9, 0xAC, 0xC5, 0x91, 0x6E, 0x9B, 0x98, 0x93, 0x83, 0xA5, 0xEF, 0xCE, 0x26, 0x22, 0xB8, 0x10, 0x89, 0x6C, 0x37, 0xC1, 0xB6, 0x7E, 0x72, 0x76, 0x83, 0x53, 0x04, 0x3D, 0x95,
  0xC6, 0x2B, 0xBC, 0xB6, 0xC2, 0x87, 0xA0, 0xB3, 0x50, 0x65, 0xFA, 0x34, 0xEC, 0xEC, 0x03, 0xCE, 0xAE, 0x99, 0xA0, 0x61, 0xBD, 0xE8, 0x02, 0x8E, 0xA9, 0x1A, 0xBE, 0x80, 0xFB, 0x11, 0xDE, 0x6E, 0xBF, 0x6D, 0x61, 0x36, 0x9A, 0xF8, 0x1A, 0x10,
  0x24, 0x38, 0x96, 0x55, 0xC8, 0x0A, 0xCB, 0x2A, 0xFC, 0x58, 0xD0, 0x4E, 0x35, 0xBA, 0xFC, 0xDD, 0x39, 0xEC, 0x4C, 0xD3, 0xFB, 0x89, 0x1A, 0x91, 0xDE, 0x9F, 0xE4, 0x27, 0xCC, 0x8A, 0xAE, 0xC8, 0x7D, 0x5B, 0x05, 0xB1, 0x55, 0xDC, 0x18, 0xFC,
  0x3C, 0x10, 0xA9, 0xB1, 0xEE, 0x47, 0xEB, 0x72, 0xA6, 0x04, 0x5B, 0x11, 0x3A, 0xE4, 0x5D, 0xFA, 0xD1, 0x15, 0x86, 0xBA, 0x6C, 0x5B, 0x4D, 0xA2, 0xF7, 0x90, 0xE7, 0xF2, 0x8B, 0xD4, 0x79, 0xFA, 0xF2, 0xD4, 0x81, 0x76, 0xFB, 0xBA, 0x47, 0x9A,
  0xDD, 0x54, 0x83, 0x61, 0x93, 0xE5, 0xA6, 0xDF, 0xBB, 0x12, 0x16, 0xFC, 0x46, 0xEA, 0x16, 0x1C, 0x9E, 0x51, 0x00, 0x7B, 0x64, 0x0F, 0xEF, 0x63, 0x55, 0xCC, 0xB0, 0xE9, 0x35, 0x28, 0x3A, 0xCF, 0x97, 0xEE, 0xAC, 0x47, 0xC0, 0xCE, 0x7F, 0x33,
  0xDB, 0xBA, 0x3F, 0x70, 0x44, 0x85, 0x28, 0xBF, 0x0F, 0x9E, 0xFC, 0x0F, 0xC3, 0x2B, 0x6E, 0x93, 0xEC, 0x3B, 0xE0, 0x9D, 0xFF, 0x21, 0xF8, 0xCE, 0x5A, 0x7A, 0xA5, 0x1A, 0x4A, 0x4D, 0xEC, 0x6B, 0xD7, 0xF5, 0x4D, 0x9F, 0xBB, 0xDF, 0x84, 0x5A,
  0x1D, 0xFE, 0xF5, 0x7A, 0x7D, 0xBD, 0xFE, 0x07, 0x4F, 0x96, 0x90, 0x7D, 0x60, 0x13, 0x00, 0x00, 0x00
};

// Initialize your webserver
ESP8266WebServer server(80);

// Instantiate parameter attribute of the api specification, it contains only 2 elements: the pointer to the bytes in flash and the length
const OpenApiSpec spec = { swagger_json, 1136 };

void setup() {
  // put your setup code here, to run once:

  // Connect WiFi to your AP
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);

  // Wait for connection
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());

  // Broadcast MDNS for the device -> should correspond to esp8266.local if your computer/network is compatible
  if (MDNS.begin("esp8266")) {
    Serial.println("MDNS responder started");
  }

  // Call once to expose the SwaggerUI interface on your webserver (takes as parameter the webserver and the specification attributes):
  setup_swagger_ui(server, spec);
}

void loop() {
  // put your main code here, to run repeatedly:
  server.handleClient();
  MDNS.update();
}